stages:
    - build
    - test
    - post deploy

build:
    stage: build
    image: openjdk:12-alpine
    script:
        - sed -i "s/CI_PIPELINE_IID/$CI_PIPELINE_IID/" ./src/main/resources/application.yml
        - sed -i "s/CI_COMMIT_SHORT_SHA/$CI_COMMIT_SHORT_SHA/" ./src/main/resources/application.yml
        - sed -i "s/CI_COMMIT_BRANCH/$CI_COMMIT_BRANCH/" ./src/main/resources/application.yml
        - ./gradlew build
    artifacts:
        paths:
            - ./build/libs/

smoke test:
    stage: test
    image: openjdk:12-alpine
    before_script:
        - apk --no-cache add curl
    script:
        - java -jar ./build/libs/cars-api.jar &
        - sleep 30
        - curl http://localhost:5000/actuator/health | grep "UP"

code quality:
    stage: test
    image: openjdk:12-alpine
    script:
        - ./gradlew pmdMain pmdTest
    artifacts:
        when: always
        paths:
            - build/pmd/report

unit test:
    stage: test
    image: openjdk:12-alpine
    script:
        - ./gradlew test
    artifacts:
        when: always
        paths:
            - build/reports/tests
        reports:
            junit: build/test-results/test/*.xml         

api testing:
  stage: post deploy
  image:
    name: vdespa/newman
    entrypoint: [""]
  script:
    - newman --version
    - newman run "Cars API.postman_collection.json" --environment Localhost.postman_environment.json --reporters cli,htmlextra,junit --reporter-htmlextra-export "newman/report.html" --reporter-junit-export "newman/report.xml"
  artifacts:
    when: always
    paths:
      - newman/
    reports:
      junit: newman/report.xml
